/*

  KeyMouse.C

  Author: mergerly
  Last Updated: 2009-11-19

*/

#include <ntddk.h>
#include <ntddkbd.h>

#include "KeyMouse.h"
#include "struct.h"
#include "pe.h"

#define MOUSE_EVENT
#ifdef MOUSE_EVENT
	#include <ntddmou.h>
#endif

#define dprintf if (DBG) DbgPrint
#define nprintf DbgPrint

#define kmalloc(_s)	ExAllocatePoolWithTag(NonPagedPool, _s, 'SYSQ')
//#define kfree(_p)	ExFreePoolWithTag(_p, 'SYSQ')
#define kfree(_p)	ExFreePool(_p)

//
// A structure representing the instance information associated with
// a particular device
//

typedef struct _DEVICE_EXTENSION
{
    ULONG  StateVariable;

} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

//
// Device driver routine declarations.
//

NTSTATUS
DriverEntry(
	IN PDRIVER_OBJECT		DriverObject,
	IN PUNICODE_STRING		RegistryPath
	);

NTSTATUS
KeymouseDispatchCreate(
	IN PDEVICE_OBJECT		DeviceObject,
	IN PIRP					Irp
	);

NTSTATUS
KeymouseDispatchClose(
	IN PDEVICE_OBJECT		DeviceObject,
	IN PIRP					Irp
	);

NTSTATUS
KeymouseDispatchDeviceControl(
	IN PDEVICE_OBJECT		DeviceObject,
	IN PIRP					Irp
	);

VOID
KeymouseUnload(
	IN PDRIVER_OBJECT		DriverObject
	);

#ifdef ALLOC_PRAGMA
#pragma alloc_text(INIT, DriverEntry)
#pragma alloc_text(PAGE, KeymouseDispatchCreate)
#pragma alloc_text(PAGE, KeymouseDispatchClose)
#pragma alloc_text(PAGE, KeymouseDispatchDeviceControl)
#pragma alloc_text(PAGE, KeymouseUnload)
#endif // ALLOC_PRAGMA

//////////////////////////////////////////////////////////////////////////

#define PROLOG __asm { pushad } __asm { pushfd } 
#define RETURN __asm { popfd } __asm { popad } __asm { pop eax } __asm{ mov eax, 0xC000000D } __asm{ ret } 
#define EPILOG __asm { popfd } __asm { popad } __asm { ret } 



typedef VOID
(*My_KeyboardClassServiceCallback) (
									PDEVICE_OBJECT  DeviceObject,
									PKEYBOARD_INPUT_DATA  InputDataStart,
									PKEYBOARD_INPUT_DATA  InputDataEnd,
									PULONG  InputDataConsumed
									);
#ifdef MOUSE_EVENT

typedef VOID
(*My_MouseClassServiceCallback) (
								    PDEVICE_OBJECT  DeviceObject,
									PMOUSE_INPUT_DATA  InputDataStart,
									PMOUSE_INPUT_DATA  InputDataEnd,
									PULONG  InputDataConsumed
									);
My_MouseClassServiceCallback orig_MouseClassServiceCallback = NULL;
#endif
My_KeyboardClassServiceCallback orig_KeyboardClassServiceCallback = NULL;

//////////////////////////////////////////////////////////////////////////

ULONG g_kbdclass_base ;
ULONG g_lpKbdServiceCallback ;
PDEVICE_OBJECT g_kbDeviceObject = NULL;
KEYBOARD_INPUT_DATA kid;

ULONG code1_sp2=0x8b55ff8b, code2_sp2=0x8b5151ec, code3_sp2=0x65830845,code4_sp2=0x8b530008;

#ifdef MOUSE_EVENT
ULONG g_mouclass_base ;
ULONG g_lpmouServiceCallback ;
PDEVICE_OBJECT g_mouDeviceObject = NULL;
MOUSE_INPUT_DATA mid;

ULONG mcode1_sp2=0x8b55ff8b, mcode2_sp2=0x8b5151ec, mcode3_sp2=0x4d8b0845,mcode4_sp2=0x8b56530c;
#endif
/*
kd> dd kbdclass!KeyboardClassServiceCallback
f9ca5192  8b55ff8b 8b5151ec 65830845 8b530008
f9ca51a2  5d2b105d 708b560c 14458b28 57002083

kbdclass!KeyboardClassServiceCallback:
f9ca5192 8bff            mov     edi,edi
f9ca5194 55              push    ebp
f9ca5195 8bec            mov     ebp,esp
f9ca5197 51              push    ecx
f9ca5198 51              push    ecx
f9ca5199 8b4508          mov     eax,dword ptr [ebp+8]
f9ca519c 83650800        and     dword ptr [ebp+8],0
f9ca51a0 53              push    ebx
f9ca51a1 8b5d10          mov     ebx,dword ptr [ebp+10h]
f9ca51a4 2b5d0c          sub     ebx,dword ptr [ebp+0Ch]
f9ca51a7 56              push    esi
f9ca51a8 8b7028          mov     esi,dword ptr [eax+28h]
f9ca51ab 8b4514          mov     eax,dword ptr [ebp+14h]
f9ca51ae 832000          and     dword ptr [eax],0
f9ca51b1 57              push    edi
f9ca51b2 6a04            push    4

kd> dd mouclass!MouseClassServiceCallback
f9cb4f34  8b55ff8b 8b5151ec 4d8b0845 8b56530c
f9cb4f44  458b2870 89c12b10 458b0845 89db3314

mouclass!MouseClassServiceCallback:
f9cb4f34 8bff            mov     edi,edi
f9cb4f36 55              push    ebp
f9cb4f37 8bec            mov     ebp,esp
f9cb4f39 51              push    ecx
f9cb4f3a 51              push    ecx
f9cb4f3b 8b4508          mov     eax,dword ptr [ebp+8]
f9cb4f3e 8b4d0c          mov     ecx,dword ptr [ebp+0Ch]
f9cb4f41 53              push    ebx
f9cb4f42 56              push    esi
f9cb4f43 8b7028          mov     esi,dword ptr [eax+28h]
f9cb4f46 8b4510          mov     eax,dword ptr [ebp+10h]
f9cb4f49 2bc1            sub     eax,ecx
f9cb4f4b 894508          mov     dword ptr [ebp+8],eax
f9cb4f4e 8b4514          mov     eax,dword ptr [ebp+14h]
f9cb4f51 33db            xor     ebx,ebx
f9cb4f53 8918            mov     dword ptr [eax],ebx

f9ca4000 f9ca9b00   kbdclass
f9cb4000 f9cb9500   mouclass
*/

//////////////////////////////////////////////////////////////////////////

PVOID 
GetModlueBaseAdress(
					char* ModlueName,
					BOOL bKernelBase
					)
{
	ULONG size,index;
	PULONG buf;
	NTSTATUS status;
	PSYSTEM_MODULE_INFORMATION module;
	PVOID driverAddress=0;

	ZwQuerySystemInformation(SystemModuleInformation,&size, 0, &size);
	if(NULL==(buf = (PULONG)ExAllocatePool(PagedPool, size))){
		DbgPrint("failed alloc memory failed \n");
		return 0;
	}

	status=ZwQuerySystemInformation(SystemModuleInformation,buf, size , 0);
	if(!NT_SUCCESS( status )) {
		DbgPrint("failed query\n");
		return 0;
	}

	module = (PSYSTEM_MODULE_INFORMATION)(( PULONG )buf + 1);

	// ϵͳģַ
	if ( TRUE == bKernelBase )
	{
		driverAddress = module[0].Base;
		DbgPrint("KernelBase:%x\n",driverAddress);
		goto _x_;
	}

	// ģַ
	for (index = 0; index < *buf; index++) {
		if (_stricmp(module[index].ImageName + module[index].ModuleNameOffset, ModlueName) == 0) 
		{
			driverAddress = module[index].Base;
			DbgPrint("Module found at:%x\n",driverAddress);
			goto _x_;
		}
	}

_x_:		
	ExFreePool(buf);
	return driverAddress;
}

NTSTATUS KbdInit( IN PDRIVER_OBJECT DriverObject) 
{
	UNICODE_STRING ntUnicodeString;
	NTSTATUS ntStatus;
	PDEVICE_OBJECT DeviceObject = NULL;
	PDEVICE_OBJECT			TargetDeviceObject = NULL;
	PFILE_OBJECT			TargetFileObject	= NULL;

	RtlInitUnicodeString( &ntUnicodeString, L"\\Device\\KeyboardClass0" );
	ntStatus = IoGetDeviceObjectPointer(IN	&ntUnicodeString,
		IN	FILE_ALL_ACCESS,
		OUT	&TargetFileObject,   
		OUT	&g_kbDeviceObject
		);
	if( !NT_SUCCESS(ntStatus) )
	{
		DbgPrint(("Couldn't Get the Keyboard Device Object\n"));

		TargetFileObject	= NULL;
		g_kbDeviceObject = NULL;	
		return( ntStatus );
	}	 

	return STATUS_SUCCESS;
}

NTSTATUS MouInit( IN PDRIVER_OBJECT DriverObject) 
{
	UNICODE_STRING ntUnicodeString;
	NTSTATUS ntStatus;
	PDEVICE_OBJECT DeviceObject = NULL;
	PDEVICE_OBJECT			TargetDeviceObject = NULL;
	PFILE_OBJECT			TargetFileObject	= NULL;

	RtlInitUnicodeString( &ntUnicodeString, L"\\Device\\PointerClass0" );
	ntStatus = IoGetDeviceObjectPointer(IN	&ntUnicodeString,
		IN	FILE_ALL_ACCESS,
		OUT	&TargetFileObject,   
		OUT	&g_mouDeviceObject
		);
	if( !NT_SUCCESS(ntStatus) )
	{
		DbgPrint(("Couldn't Get the Mouse Device Object\n"));

		TargetFileObject	= NULL;
		g_mouDeviceObject = NULL;	
		return( ntStatus );
	}	 

	return STATUS_SUCCESS;
}

NTSTATUS
DriverEntry(
	IN PDRIVER_OBJECT		DriverObject,
	IN PUNICODE_STRING		RegistryPath
	)
{
	NTSTATUS			status = STATUS_SUCCESS;    
    UNICODE_STRING		ntDeviceName;
	UNICODE_STRING		dosDeviceName;
    PDEVICE_EXTENSION	deviceExtension;
	PDEVICE_OBJECT		deviceObject = NULL;
	BOOLEAN				fSymbolicLink = FALSE;

	ULONG i, curAddr;
	PUCHAR FileContent;
	DWORD dwRet,dwSize;
	PVOID pTmp;

	//KdBreakPoint();

    dprintf("[KeyMouse] DriverEntry: %wZ\n", RegistryPath);

    //
    // A real driver would:
    //
    //     1. Report it's resources (IoReportResourceUsage)
    //
    //     2. Attempt to locate the device(s) it supports

    //
    // OK, we've claimed our resources & found our h/w, so create
    // a device and initialize stuff...
    //

    RtlInitUnicodeString(&ntDeviceName, KEYMOUSE_DEVICE_NAME_W);

    //
    // Create an EXCLUSIVE device, i.e. only 1 thread at a time can send
    // i/o requests.
    //

    status = IoCreateDevice(
		DriverObject,
		sizeof(DEVICE_EXTENSION), // DeviceExtensionSize
		&ntDeviceName, // DeviceName
		FILE_DEVICE_KEYMOUSE, // DeviceType
		0, // DeviceCharacteristics
		TRUE, // Exclusive
		&deviceObject // [OUT]
		);

    if (!NT_SUCCESS(status))
	{
		dprintf("[KeyMouse] IoCreateDevice = 0x%x\n", status);
		goto __failed;
	}

	deviceExtension = (PDEVICE_EXTENSION)deviceObject->DeviceExtension;

	//
	// Set up synchronization objects, state info,, etc.
	//

    //
    // Create a symbolic link that Win32 apps can specify to gain access
    // to this driver/device
    //

    RtlInitUnicodeString(&dosDeviceName, KEYMOUSE_DOS_DEVICE_NAME_W);

    status = IoCreateSymbolicLink(&dosDeviceName, &ntDeviceName);

    if (!NT_SUCCESS(status))
    {
        dprintf("[KeyMouse] IoCreateSymbolicLink = 0x%x\n", status);
		goto __failed;
    }

	fSymbolicLink = TRUE;

    //
    // Create dispatch points for device control, create, close.
    //

    DriverObject->MajorFunction[IRP_MJ_CREATE]         = KeymouseDispatchCreate;
    DriverObject->MajorFunction[IRP_MJ_CLOSE]          = KeymouseDispatchClose;
    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = KeymouseDispatchDeviceControl;
    DriverObject->DriverUnload                         = KeymouseUnload;

	//
	// ִд
	//

	KbdInit(DriverObject);

	g_kbdclass_base = (ULONG)GetModlueBaseAdress( "kbdclass.sys",0 );
	DbgPrint("kbdclass.sys: 0x%08lx\n", (PVOID)g_kbdclass_base);

	if ( 0 == g_kbdclass_base ) {
		DbgPrint("ERROR: g_kbdclass_base == 0\n");
		goto __failed;
	}

	curAddr = g_kbdclass_base;
	//	DbgPrint("curAddr: 0x%08lx\n", curAddr);
	for (i=curAddr;i<=curAddr+0x2000;i++)
	{
		//	DbgPrint("i: 0x%08lx\n", i);
		if (*((ULONG *)i)==code1_sp2) {
			if (*((ULONG *)(i+4))==code2_sp2) {
				if (*((ULONG *)(i+8))==code3_sp2) {
					if (*((ULONG *)(i+12))==code4_sp2) {
						g_lpKbdServiceCallback=i;
						break ;
					}
				}
			}
		}
	}

	orig_KeyboardClassServiceCallback = (My_KeyboardClassServiceCallback)g_lpKbdServiceCallback;
	DbgPrint("KeyboardClassServiceCallback: 0x%08lx\n", (PVOID)g_lpKbdServiceCallback);

	if ( 0 == g_lpKbdServiceCallback ) {
		DbgPrint("ERROR: g_lpKbdServiceCallback == 0\n");
		goto __failed;
	}

#ifdef MOUSE_EVENT
	status = MouInit(DriverObject);
	if(!NT_SUCCESS(status))
	{
		DbgPrint("ERROR: MouInit = 0x%08lx\n", status);
		goto __failed;
	}
	g_mouclass_base = (ULONG)GetModlueBaseAdress( "mouclass.sys",0 );
	DbgPrint("mouclass.sys: 0x%08lx\n", (PVOID)g_mouclass_base);

	if ( 0 == g_mouclass_base ) {
		DbgPrint("ERROR: g_mouclass_base == 0\n");
		goto __failed;
	}

	curAddr = g_mouclass_base;
	//	DbgPrint("curAddr: 0x%08lx\n", curAddr);
	for (i=curAddr;i<=curAddr+0x2000;i++)
	{
		//	DbgPrint("i: 0x%08lx\n", i);
		if (*((ULONG *)i)==mcode1_sp2) {
			if (*((ULONG *)(i+4))==mcode2_sp2) {
				if (*((ULONG *)(i+8))==mcode3_sp2) {
					if (*((ULONG *)(i+12))==mcode4_sp2) {
						g_lpmouServiceCallback=i;
						break ;
					}
				}
			}
		}
	}

	orig_MouseClassServiceCallback = (My_MouseClassServiceCallback)g_lpmouServiceCallback;
	DbgPrint("MouseClassServiceCallback: 0x%08lx g_mouDeviceObject:0x%08lx\n", (PVOID)g_lpmouServiceCallback, (PVOID)g_mouDeviceObject);

	if ( 0 == g_lpmouServiceCallback ) {
		DbgPrint("ERROR: g_lpmouServiceCallback == 0\n");
		goto __failed;
	}
#endif

	if (NT_SUCCESS(status))
	    return status;

__failed:

	if (fSymbolicLink)
		IoDeleteSymbolicLink(&dosDeviceName);

	if (deviceObject)
		IoDeleteDevice(deviceObject);

	return status;
}

NTSTATUS
KeymouseDispatchCreate(
	IN PDEVICE_OBJECT		DeviceObject,
	IN PIRP					Irp
	)
{
	NTSTATUS status = STATUS_SUCCESS;

    Irp->IoStatus.Information = 0;

	dprintf("[KeyMouse] IRP_MJ_CREATE\n");

    Irp->IoStatus.Status = status;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    return status;
}

NTSTATUS
KeymouseDispatchClose(
	IN PDEVICE_OBJECT		DeviceObject,
	IN PIRP					Irp
	)
{
	NTSTATUS status = STATUS_SUCCESS;

    Irp->IoStatus.Information = 0;

	dprintf("[KeyMouse] IRP_MJ_CLOSE\n");

    Irp->IoStatus.Status = status;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    return status;
}

NTSTATUS
KeymouseDispatchDeviceControl(
	IN PDEVICE_OBJECT		DeviceObject,
	IN PIRP					Irp
	)
{
	NTSTATUS			status = STATUS_SUCCESS;
    PIO_STACK_LOCATION	irpStack;
    PDEVICE_EXTENSION	deviceExtension;
    PVOID				ioBuf;
    ULONG				inBufLength, outBufLength;
	ULONG				ioControlCode;

	ULONG				lKeyCode;
	DWORD				dwRet,dwSize;

	USHORT 				MouseFlags;
	ULONG 				InputDataConsumed;
	PMOUSE_INPUT_DATA 	InputDataStart, InputDataEnd;
	KIRQL 				oldirq;

    irpStack = IoGetCurrentIrpStackLocation(Irp);
    deviceExtension = (PDEVICE_EXTENSION)DeviceObject->DeviceExtension;

    Irp->IoStatus.Information = 0;

    //
    // Get the pointer to the input/output buffer and it's length
    //

    ioBuf = Irp->AssociatedIrp.SystemBuffer;
    inBufLength = irpStack->Parameters.DeviceIoControl.InputBufferLength;
    outBufLength = irpStack->Parameters.DeviceIoControl.OutputBufferLength;
    ioControlCode = irpStack->Parameters.DeviceIoControl.IoControlCode;

    switch (ioControlCode)
    {
	case IOCTL_KEYMOUSE_HELLO:
		{
			//
			// Some app is saying hello
			//

            break;
		}
	case IOCTL_KEY_DOWN	:
		{
			if (ioBuf)
			{
				lKeyCode = *(ULONG*)ioBuf;
				dprintf("[KeyMouse] KeymouseDispatchDeviceControl IOCTL_KEY_DOWN = 0x%x\n", lKeyCode);
				dwSize = sizeof(KEYBOARD_INPUT_DATA);
				__asm {
					push eax
						mov	kid.UnitId,0		;  KEYBOARD_INPUT_DATA 
						mov	eax,lKeyCode
						mov	kid.MakeCode,ax
						mov	kid.Flags,KEY_MAKE	;ģⰴ
						mov	kid.Reserved,0
						mov	kid.ExtraInformation,0

						lea	eax,dwRet
						push	eax
						lea	eax,kid
						add	eax,dwSize
						push	eax
						lea	eax,kid
						push	eax
						push	g_kbDeviceObject
						call	orig_KeyboardClassServiceCallback	; KeyboardClassServiceCallback ģⰴ

						pop eax
				}				
				status = STATUS_SUCCESS;
			}
			break;
		}
	case IOCTL_KEY_UP:
		{
			if (ioBuf)
			{
				lKeyCode = *(ULONG*)ioBuf;
				dprintf("[KeyMouse] KeymouseDispatchDeviceControl IOCTL_KEY_UP = 0x%x\n", lKeyCode);
				dwSize = sizeof(KEYBOARD_INPUT_DATA);
				__asm {
					push eax
						mov	kid.UnitId,0		;  KEYBOARD_INPUT_DATA 
						mov	eax,lKeyCode
						mov	kid.MakeCode,ax
						mov	kid.Flags,KEY_BREAK	;ģɿ
						mov	kid.Reserved,0
						mov	kid.ExtraInformation,0

						lea	eax,dwRet
						push	eax
						lea	eax,kid
						add	eax,dwSize
						push	eax
						lea	eax,kid
						push	eax
						push	g_kbDeviceObject
						call	orig_KeyboardClassServiceCallback	; KeyboardClassServiceCallback ģⰴ

						pop eax
				}
				status = STATUS_SUCCESS;
			}			
			break;
		}
	case IOCTL_KEY_E0:
		{
			if (ioBuf)
			{
				lKeyCode = *(ULONG*)ioBuf;
				dprintf("[KeyMouse] KeymouseDispatchDeviceControl IOCTL_KEY_E0 = 0x%x\n", lKeyCode);
				dwSize = sizeof(KEYBOARD_INPUT_DATA);
				__asm {
					push eax
						mov	kid.UnitId,0		;  KEYBOARD_INPUT_DATA 
						mov	eax,lKeyCode
						mov	kid.MakeCode,ax
						mov	kid.Flags,KEY_E0	;ģⰴ
						mov	kid.Reserved,0
						mov	kid.ExtraInformation,0

						lea	eax,dwRet
						push	eax
						lea	eax,kid
						add	eax,dwSize
						push	eax
						lea	eax,kid
						push	eax
						push	g_kbDeviceObject
						call	orig_KeyboardClassServiceCallback	; KeyboardClassServiceCallback ģⰴ

						pop eax
				}				
				status = STATUS_SUCCESS;
			}
			break;
		}
	case IOCTL_KEY_E1:
		{
			if (ioBuf)
			{
				lKeyCode = *(ULONG*)ioBuf;
				dprintf("[KeyMouse] KeymouseDispatchDeviceControl IOCTL_KEY_E1 = 0x%x\n", lKeyCode);
				dwSize = sizeof(KEYBOARD_INPUT_DATA);
				__asm {
					push eax
						mov	kid.UnitId,0		;  KEYBOARD_INPUT_DATA 
						mov	eax,lKeyCode
						mov	kid.MakeCode,ax
						mov	kid.Flags,KEY_E1	;ģɿ
						mov	kid.Reserved,0
						mov	kid.ExtraInformation,0

						lea	eax,dwRet
						push	eax
						lea	eax,kid
						add	eax,dwSize
						push	eax
						lea	eax,kid
						push	eax
						push	g_kbDeviceObject
						call	orig_KeyboardClassServiceCallback	; KeyboardClassServiceCallback ģⰴ

						pop eax
				}
				status = STATUS_SUCCESS;
			}
			break;
		}
	case IOCTL_MOUSE_LEFT_BUTTON_DOWN:	
		{
			MouseFlags = MOUSE_LEFT_BUTTON_DOWN;
			goto __MouseCallBack;
		}
	case IOCTL_MOUSE_LEFT_BUTTON_UP:
		{
			MouseFlags = MOUSE_LEFT_BUTTON_UP;
			goto __MouseCallBack;
		}
	case IOCTL_MOUSE_RIGHT_BUTTON_DOWN:
		{
			MouseFlags = MOUSE_RIGHT_BUTTON_DOWN;
			goto __MouseCallBack;
		}
	case IOCTL_MOUSE_RIGHT_BUTTON_UP:	
		{
			MouseFlags = MOUSE_RIGHT_BUTTON_UP;
			goto __MouseCallBack;
		}
	case IOCTL_MOUSE_MIDDLE_BUTTON_DOWN:	
		{
			MouseFlags = MOUSE_MIDDLE_BUTTON_DOWN;
			goto __MouseCallBack;
		}
	case IOCTL_MOUSE_MIDDLE_BUTTON_UP:
		{
			MouseFlags = MOUSE_MIDDLE_BUTTON_UP;
__MouseCallBack:
			mid.UnitId = 0;
			mid.Flags = MOUSE_MOVE_RELATIVE;
			mid.Buttons = 0;
			mid.ButtonFlags = MouseFlags;
			mid.RawButtons = 0;
			mid.LastX = *((ULONG*)ioBuf);
			mid.LastY = *((ULONG*)ioBuf+1);
			mid.ExtraInformation = 0;

			InputDataStart = &mid;
			InputDataEnd = InputDataStart+1;

			orig_MouseClassServiceCallback(
			g_mouDeviceObject,
			InputDataStart,
			InputDataEnd,
			&InputDataConsumed
			);

			status = STATUS_SUCCESS;
			break;
		}
	case IOCTL_MOUSE_MOVE_RELATIVE:
		{
			mid.Flags = MOUSE_MOVE_RELATIVE;	//
			goto __MouseMoveCallBack;
		}
	case IOCTL_MOUSE_MOVE_ABSOLUTE:
		{
			mid.Flags = MOUSE_MOVE_ABSOLUTE;	//
			goto __MouseMoveCallBack;
		}
	case IOCTL_MOUSE_VIRTUAL_DESKTOP:
		{
			mid.Flags = MOUSE_VIRTUAL_DESKTOP;	//
__MouseMoveCallBack:
			mid.UnitId = 1;		
			mid.Buttons = 0;

			mid.RawButtons = 0;
			mid.LastX = *((ULONG*)ioBuf);
			mid.LastY = *((ULONG*)ioBuf+1);
			mid.ExtraInformation = 0;

			InputDataStart = &mid;
			InputDataEnd = InputDataStart+1;

			orig_MouseClassServiceCallback(
			g_mouDeviceObject,
			InputDataStart,
			InputDataEnd,
			&InputDataConsumed
			);
			status = STATUS_SUCCESS;
			break;
		}
    default:
        status = STATUS_INVALID_PARAMETER;

        dprintf("[KeyMouse] unknown IRP_MJ_DEVICE_CONTROL = 0x%x (%04x,%04x)\n",
			ioControlCode, DEVICE_TYPE_FROM_CTL_CODE(ioControlCode),
			IoGetFunctionCodeFromCtlCode(ioControlCode));

        break;
	}

    //
    // DON'T get cute and try to use the status field of
    // the irp in the return status.  That IRP IS GONE as
    // soon as you call IoCompleteRequest.
    //

    Irp->IoStatus.Status = status;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    //
    // We never have pending operation so always return the status code.
    //

    return status;
}

VOID
KeymouseUnload(
	IN PDRIVER_OBJECT		DriverObject
	)
{
    UNICODE_STRING dosDeviceName;

	//
    // Free any resources
    //

    //
    // Delete the symbolic link
    //

    RtlInitUnicodeString(&dosDeviceName, KEYMOUSE_DOS_DEVICE_NAME_W);

    IoDeleteSymbolicLink(&dosDeviceName);

    //
    // Delete the device object
    //

    IoDeleteDevice(DriverObject->DeviceObject);

    dprintf("[KeyMouse] unloaded\n");
}